#include <stdio.h>

#define MAXN 10000
#define INF 100000

#define BOUNDX 300
#define BOUNDY 300
#define MARGIN 30
#define LINE_WIDTH 0.01

int N, M;
int V[MAXN+1][2];

int main(void)
{
	int P, i, j, a, b, minx, maxx, miny, maxy;

	printf("%%!PS-Adobe-1.0\n");
	printf("%%%%BoundingBox: %d %d %d %d\n", 0, 0, BOUNDX, BOUNDY);
	printf("/Times-Roman findfont 10 scalefont setfont");

	scanf("%d ", &P);
	for (i=0; i<P; i++)
	{
		minx = miny = INF;
		maxx = maxy = -INF;

		scanf("%d %d ", &N, &M);
		for (j=1; j<=N; j++)
		{
			scanf("%d %d ", &V[j][0], &V[j][1]);
			if (maxx < V[j][0]) maxx = V[j][0];
			if (maxy < V[j][1]) maxy = V[j][1];
			if (minx > V[j][0]) minx = V[j][0];
			if (miny > V[j][1]) miny = V[j][1];
		}

		printf("\n");
		printf("%%%%Page: %d %d\n", i+1, i+1);
		printf("gsave\n");
		printf("%d %d translate\n", MARGIN, MARGIN);
		printf("%.4f %.4f scale\n",
			(double) (BOUNDX-2*MARGIN) / (double) (maxx-minx),
			(double) (BOUNDY-2*MARGIN) / (double) (maxy-miny));
		printf("%d %d translate\n", -minx, -miny);
		printf("%f setlinewidth\n", LINE_WIDTH);

		for (j=0; j<M; j++)
		{
			scanf("%d %d ", &a, &b);
			printf("newpath\n");
			printf("%d %d moveto\n", V[a][0], V[a][1]);
			printf("%d %d lineto\n", V[b][0], V[b][1]);
			printf("closepath stroke\n");
		}

		for (j=1; j<=N; j++)
		{
			printf("newpath\n");
			printf("%f %f moveto\n", V[j][0]-0.1, V[j][1]-0.1);
			printf("%f %f lineto\n", V[j][0]+0.1, V[j][1]-0.1);
			printf("%f %f lineto\n", V[j][0]+0.1, V[j][1]+0.1);
			printf("%f %f lineto\n", V[j][0]-0.1, V[j][1]+0.1);
			printf("%f %f lineto\n", V[j][0]-0.1, V[j][1]-0.1);
			printf("closepath fill\n");
		}

		printf("grestore\n");
		printf("showpage\n");
	}

	return 0;
}
